<html>
<head>
<title>OgreImage.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreImage.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreImage_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _Image_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _Image_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgrePixelFormat_8h.html">OgrePixelFormat.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00044"></a><a class="code" href="group__Image.html#ga975bb6abd3c277b9a91d849367885474">00044</a>     <span class="keyword">enum</span> <a class="code" href="group__Image.html#ga975bb6abd3c277b9a91d849367885474">ImageFlags</a>
<a name="l00045"></a>00045     {
<a name="l00046"></a><a class="code" href="group__Image.html#gga975bb6abd3c277b9a91d849367885474a57aedd76ae3b852c5ff6dec30d6df4fe">00046</a>         <a class="code" href="group__Image.html#gga975bb6abd3c277b9a91d849367885474a57aedd76ae3b852c5ff6dec30d6df4fe">IF_COMPRESSED</a> = 0x00000001,
<a name="l00047"></a><a class="code" href="group__Image.html#gga975bb6abd3c277b9a91d849367885474ae53b467393ae6fd94277782dd276b620">00047</a>         <a class="code" href="group__Image.html#gga975bb6abd3c277b9a91d849367885474ae53b467393ae6fd94277782dd276b620">IF_CUBEMAP</a>    = 0x00000002,
<a name="l00048"></a><a class="code" href="group__Image.html#gga975bb6abd3c277b9a91d849367885474a208116a07b56e2f93b38333acfeadba4">00048</a>         <a class="code" href="group__Image.html#gga975bb6abd3c277b9a91d849367885474a208116a07b56e2f93b38333acfeadba4">IF_3D_TEXTURE</a> = 0x00000004
<a name="l00049"></a>00049     };
<a name="l00061"></a><a class="code" href="classOgre_1_1Image.html">00061</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ImageAlloc</a>
<a name="l00062"></a>00062     {
<a name="l00063"></a>00063     <span class="keyword">public</span>:
<a name="l00064"></a><a class="code" href="classOgre_1_1Image.html#abd443d16124b2b012b77a282f2af909a">00064</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Ogre::Box</a> <a class="code" href="classOgre_1_1Image.html#abd443d16124b2b012b77a282f2af909a">Box</a>;
<a name="l00065"></a><a class="code" href="classOgre_1_1Image.html#aacf1f2552048b7c6d5e94d6746d9186b">00065</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1TRect.html">Ogre::Rect</a> <a class="code" href="classOgre_1_1Image.html#aacf1f2552048b7c6d5e94d6746d9186b">Rect</a>;
<a name="l00066"></a>00066     <span class="keyword">public</span>:
<a name="l00069"></a>00069         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a>();
<a name="l00072"></a>00072         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp;img );
<a name="l00073"></a>00073 
<a name="l00076"></a>00076         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a>();
<a name="l00077"></a>00077 
<a name="l00080"></a>00080         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp; operator = ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp; img );
<a name="l00081"></a>00081 
<a name="l00101"></a>00101         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp; flipAroundY();
<a name="l00102"></a>00102 
<a name="l00117"></a>00117         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp; flipAroundX();
<a name="l00118"></a>00118 
<a name="l00165"></a>00165         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a>&amp; loadDynamicImage( <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* data, <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height, 
<a name="l00166"></a>00166                             <span class="keywordtype">size_t</span> depth,
<a name="l00167"></a>00167                              <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format, <span class="keywordtype">bool</span> autoDelete = <span class="keyword">false</span>, 
<a name="l00168"></a>00168                              <span class="keywordtype">size_t</span> numFaces = 1, <span class="keywordtype">size_t</span> numMipMaps = 0);
<a name="l00169"></a>00169         
<a name="l00205"></a><a class="code" href="classOgre_1_1Image.html#ac7190d8948dbb16dca44de115b9f62d3">00205</a>         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a>&amp; loadDynamicImage( <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* data, <span class="keywordtype">size_t</span> width,
<a name="l00206"></a>00206                                  <span class="keywordtype">size_t</span> height, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format)
<a name="l00207"></a>00207         {
<a name="l00208"></a>00208             <span class="keywordflow">return</span> loadDynamicImage(data, width, height, 1, format);
<a name="l00209"></a>00209         }
<a name="l00229"></a>00229         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp; loadRawData( 
<a name="l00230"></a>00230             <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, 
<a name="l00231"></a>00231             <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height, <span class="keywordtype">size_t</span> depth,
<a name="l00232"></a>00232             <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format,
<a name="l00233"></a>00233             <span class="keywordtype">size_t</span> numFaces = 1, <span class="keywordtype">size_t</span> numMipMaps = 0);
<a name="l00253"></a><a class="code" href="classOgre_1_1Image.html#acea558d76dce6a1ace591a522627d5e3">00253</a>         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp; loadRawData( 
<a name="l00254"></a>00254             <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, 
<a name="l00255"></a>00255             <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height, 
<a name="l00256"></a>00256             <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format )
<a name="l00257"></a>00257         {
<a name="l00258"></a>00258             <span class="keywordflow">return</span> loadRawData(stream, width, height, 1, format);
<a name="l00259"></a>00259         }
<a name="l00260"></a>00260 
<a name="l00276"></a>00276         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp; load( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName );
<a name="l00277"></a>00277 
<a name="l00298"></a>00298         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp; load(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; type = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a> );
<a name="l00299"></a>00299 
<a name="l00310"></a>00310         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp; loadTwoImagesAsRGBA(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; rgbFilename, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; alphaFilename,
<a name="l00311"></a>00311             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format = <a class="code" href="group__Image.html#gga7e0353e7d36d4c2e8468641b7303d39cae0afb06af1cb73f624e66540c64bb2cb" title="4 byte pixel format, 1 byte for red, 1 byte for green, 1 byte for blue, and one byte for alpha...">PF_BYTE_RGBA</a>);
<a name="l00312"></a>00312 
<a name="l00328"></a>00328         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp; loadTwoImagesAsRGBA(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; rgbStream, <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; alphaStream, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> = <a class="code" href="group__Image.html#gga7e0353e7d36d4c2e8468641b7303d39cae0afb06af1cb73f624e66540c64bb2cb" title="4 byte pixel format, 1 byte for red, 1 byte for green, 1 byte for blue, and one byte for alpha...">PF_BYTE_RGBA</a>,
<a name="l00329"></a>00329             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; rgbType = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; alphaType = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00330"></a>00330 
<a name="l00340"></a>00340         <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp; combineTwoImagesAsRGBA(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a>&amp; rgb, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a>&amp; alpha, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format = <a class="code" href="group__Image.html#gga7e0353e7d36d4c2e8468641b7303d39cae0afb06af1cb73f624e66540c64bb2cb" title="4 byte pixel format, 1 byte for red, 1 byte for green, 1 byte for blue, and one byte for alpha...">PF_BYTE_RGBA</a>);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342         
<a name="l00352"></a>00352         <span class="keywordtype">void</span> save(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00353"></a>00353 
<a name="l00358"></a>00358         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> encode(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; formatextension);
<a name="l00359"></a>00359 
<a name="l00366"></a>00366         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* getData(<span class="keywordtype">void</span>);
<a name="l00367"></a>00367 
<a name="l00374"></a>00374         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a> * getData() <span class="keyword">const</span>;       
<a name="l00375"></a>00375 
<a name="l00378"></a>00378         <span class="keywordtype">size_t</span> getSize() <span class="keyword">const</span>;
<a name="l00379"></a>00379 
<a name="l00382"></a>00382         <span class="keywordtype">size_t</span> getNumMipmaps() <span class="keyword">const</span>;
<a name="l00383"></a>00383 
<a name="l00386"></a>00386         <span class="keywordtype">bool</span> hasFlag(<span class="keyword">const</span> <a class="code" href="group__Image.html#ga975bb6abd3c277b9a91d849367885474">ImageFlags</a> imgFlag) <span class="keyword">const</span>;
<a name="l00387"></a>00387 
<a name="l00390"></a>00390         <span class="keywordtype">size_t</span> getWidth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00391"></a>00391 
<a name="l00394"></a>00394         <span class="keywordtype">size_t</span> getHeight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00395"></a>00395 
<a name="l00398"></a>00398         <span class="keywordtype">size_t</span> getDepth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00399"></a>00399         
<a name="l00403"></a>00403         <span class="keywordtype">size_t</span> getNumFaces(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00404"></a>00404 
<a name="l00407"></a>00407         <span class="keywordtype">size_t</span> getRowSpan(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00408"></a>00408 
<a name="l00411"></a>00411         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> getFormat() <span class="keyword">const</span>;
<a name="l00412"></a>00412 
<a name="l00415"></a>00415         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a> getBPP() <span class="keyword">const</span>;
<a name="l00416"></a>00416 
<a name="l00419"></a>00419         <span class="keywordtype">bool</span> getHasAlpha() <span class="keyword">const</span>;
<a name="l00420"></a>00420         
<a name="l00426"></a>00426         <span class="keyword">static</span> <span class="keywordtype">void</span> applyGamma( <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a> *buffer, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> gamma, <span class="keywordtype">size_t</span> size, <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a> bpp );
<a name="l00427"></a>00427 
<a name="l00433"></a>00433         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> getColourAt(<span class="keywordtype">size_t</span> x, <span class="keywordtype">size_t</span> y, <span class="keywordtype">size_t</span> z) <span class="keyword">const</span>;
<a name="l00434"></a>00434         
<a name="l00440"></a>00440         <span class="keywordtype">void</span> setColourAt(<a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <span class="keyword">const</span> &amp;cv, <span class="keywordtype">size_t</span> x, <span class="keywordtype">size_t</span> y, <span class="keywordtype">size_t</span> z);
<a name="l00441"></a>00441 
<a name="l00445"></a>00445         <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> getPixelBox(<span class="keywordtype">size_t</span> face = 0, <span class="keywordtype">size_t</span> mipmap = 0) <span class="keyword">const</span>;
<a name="l00446"></a>00446 
<a name="l00448"></a>00448         <span class="keywordtype">void</span> freeMemory();
<a name="l00449"></a>00449 
<a name="l00450"></a><a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5">00450</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5">Filter</a>
<a name="l00451"></a>00451         {
<a name="l00452"></a><a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5a7ef2addab7f4ada3d9892979c0b309ca">00452</a>             <a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5a7ef2addab7f4ada3d9892979c0b309ca">FILTER_NEAREST</a>,
<a name="l00453"></a><a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5a4bd7e862129bad718a43406a38716a46">00453</a>             <a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5a4bd7e862129bad718a43406a38716a46">FILTER_LINEAR</a>,
<a name="l00454"></a><a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5a4d66afbe9239683a6fb6b90edb1611b5">00454</a>             <a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5a4d66afbe9239683a6fb6b90edb1611b5">FILTER_BILINEAR</a>,
<a name="l00455"></a><a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5ac05b8d3ad728faf2b99a2c3a8c9ed03c">00455</a>             <a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5ac05b8d3ad728faf2b99a2c3a8c9ed03c">FILTER_BOX</a>,
<a name="l00456"></a><a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5a100906ef66a390179993687a1975025d">00456</a>             <a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5a100906ef66a390179993687a1975025d">FILTER_TRIANGLE</a>,
<a name="l00457"></a><a class="code" href="classOgre_1_1Image.html#aa1d0fe80507583b39161736e4be198d5a0f429c684c4f0e599f9a15304205c233">00457</a>             FILTER_BICUBIC
<a name="l00458"></a>00458         };
<a name="l00466"></a>00466         <span class="keyword">static</span> <span class="keywordtype">void</span> scale(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;src, <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;dst, Filter filter = FILTER_BILINEAR);
<a name="l00467"></a>00467         
<a name="l00469"></a>00469         <span class="keywordtype">void</span> resize(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> width, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> height, Filter filter = FILTER_BILINEAR);
<a name="l00470"></a>00470         
<a name="l00471"></a>00471         <span class="comment">// Static function to calculate size in bytes from the number of mipmaps, faces and the dimensions</span>
<a name="l00472"></a>00472         <span class="keyword">static</span> <span class="keywordtype">size_t</span> calculateSize(<span class="keywordtype">size_t</span> mipmaps, <span class="keywordtype">size_t</span> faces, <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height, <span class="keywordtype">size_t</span> depth, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format);
<a name="l00473"></a>00473 
<a name="l00475"></a>00475         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getFileExtFromMagic(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> stream);
<a name="l00476"></a>00476 
<a name="l00477"></a>00477     <span class="keyword">protected</span>:
<a name="l00478"></a>00478         <span class="comment">// The width of the image in pixels</span>
<a name="l00479"></a><a class="code" href="classOgre_1_1Image.html#a072eee231e596a10479100dae7805d78">00479</a>     <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Image.html#a072eee231e596a10479100dae7805d78">mWidth</a>;
<a name="l00480"></a>00480         <span class="comment">// The height of the image in pixels</span>
<a name="l00481"></a><a class="code" href="classOgre_1_1Image.html#a901b2c08efdfac96b12fecb175cb3719">00481</a>     <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Image.html#a901b2c08efdfac96b12fecb175cb3719">mHeight</a>;
<a name="l00482"></a>00482         <span class="comment">// The depth of the image</span>
<a name="l00483"></a><a class="code" href="classOgre_1_1Image.html#ace01a137ceeb972bbe5b995db260bf58">00483</a>     <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Image.html#ace01a137ceeb972bbe5b995db260bf58">mDepth</a>;
<a name="l00484"></a>00484         <span class="comment">// The size of the image buffer</span>
<a name="l00485"></a><a class="code" href="classOgre_1_1Image.html#a3659f8542a186c2bf9bcf24bd273a493">00485</a>     <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Image.html#a3659f8542a186c2bf9bcf24bd273a493">mBufSize</a>;
<a name="l00486"></a>00486         <span class="comment">// The number of mipmaps the image contains</span>
<a name="l00487"></a><a class="code" href="classOgre_1_1Image.html#adf7c578dbf0589dbc9c7135ce3e1b10f">00487</a>     <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Image.html#adf7c578dbf0589dbc9c7135ce3e1b10f">mNumMipmaps</a>;
<a name="l00488"></a>00488         <span class="comment">// Image specific flags.</span>
<a name="l00489"></a><a class="code" href="classOgre_1_1Image.html#a248b5a680e19775a7878982209f1a32a">00489</a>     <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Image.html#a248b5a680e19775a7878982209f1a32a">mFlags</a>;
<a name="l00490"></a>00490 
<a name="l00491"></a>00491         <span class="comment">// The pixel format of the image</span>
<a name="l00492"></a><a class="code" href="classOgre_1_1Image.html#a6deb03ac1217505f407a5fec45aedaab">00492</a>     <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> <a class="code" href="classOgre_1_1Image.html#a6deb03ac1217505f407a5fec45aedaab">mFormat</a>;
<a name="l00493"></a>00493 
<a name="l00494"></a>00494         <span class="comment">// The number of bytes per pixel</span>
<a name="l00495"></a><a class="code" href="classOgre_1_1Image.html#aba44cc47c67ad5ce87afb90eeff9c4e0">00495</a>     <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a> <a class="code" href="classOgre_1_1Image.html#aba44cc47c67ad5ce87afb90eeff9c4e0">mPixelSize</a>;
<a name="l00496"></a><a class="code" href="classOgre_1_1Image.html#aa24a563bb303d1dc93ceb4de1646957b">00496</a>     <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* <a class="code" href="classOgre_1_1Image.html#aa24a563bb303d1dc93ceb4de1646957b">mBuffer</a>;
<a name="l00497"></a>00497 
<a name="l00498"></a>00498         <span class="comment">// A bool to determine if we delete the buffer or the calling app does</span>
<a name="l00499"></a><a class="code" href="classOgre_1_1Image.html#a7daf4dc689be6a6aad3b85575e6d47c7">00499</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Image.html#a7daf4dc689be6a6aad3b85575e6d47c7">mAutoDelete</a>;
<a name="l00500"></a>00500     };
<a name="l00501"></a>00501 
<a name="l00502"></a><a class="code" href="group__Image.html#gabe3f215b0c56dd98009a1060e3fb87ed">00502</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;Image*&gt;::type</a> <a class="code" href="group__Image.html#gabe3f215b0c56dd98009a1060e3fb87ed">ImagePtrList</a>;
<a name="l00503"></a><a class="code" href="group__Image.html#gad3242b650f2562b87c992002a18c395f">00503</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;const Image*&gt;::type</a> <a class="code" href="group__Image.html#gad3242b650f2562b87c992002a18c395f">ConstImagePtrList</a>;
<a name="l00504"></a>00504 
<a name="l00508"></a>00508 } <span class="comment">// namespace</span>
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
